diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -412,14 +647,14 @@ class SquadService extends Actor {
                 //generate a new squad, with invitingPlayer as the leader
                 val squad = StartSquad(invitingPlayer)
                 squad.Task = s"${invitingPlayer.Name}'s Squad"
-                SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayerCharId/Squad", SquadResponse.AssociateWithSquad(squad.GUID)) )
+                Publish(invitingPlayerCharId, SquadResponse.AssociateWithSquad(squad.GUID))
                 Some(squad)
             }) match {
               case Some(squad) =>
-                HandleVacancyInvite(squad.GUID, tplayer.CharId, invitingPlayerCharId, tplayer) match {
+                HandleVacancyInvite(squad, tplayer.CharId, invitingPlayerCharId, tplayer) match {
                   case Some((_, line)) =>
-                    SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayerCharId), "", true, Some(None))) )
-                    SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayerCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayerCharId, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
+                    Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayerCharId), "", true, Some(None)))
+                    Publish(invitingPlayerCharId, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayerCharId, Some(invitedPlayer), tplayer.Name, false, Some(None)))
                     JoinSquad(tplayer, squad, line)
                     RemoveQueuedInvites(tplayer.CharId) //TODO deal with these somehow
                   case _ => ;
@@ -427,12 +662,12 @@ class SquadService extends Actor {
               case _ => ;
             }
 
-          case Some(InviteForRole(invitingPlayer, name, guid, position)) if EnsureEmptySquad(invitedPlayer, msg) =>
+          case Some(LookingForSquadRoleInvite(invitingPlayer, name, guid, position)) if EnsureEmptySquad(invitedPlayer) =>
             squadFeatures.get(guid) match {
               case Some(features) if JoinSquad(tplayer, features.Squad, position) =>
                 //join this squad
-                SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))) )
-                SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
+                Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None)))
+                Publish(invitingPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None)))
                 RemoveQueuedInvites(tplayer.CharId)
                 features.ProxyInvites = Nil
                 features.SearchForRole = None
@@ -441,35 +676,31 @@ class SquadService extends Actor {
               case Some(features) =>
                 //can not join squad; position is unavailable or other reasons block action
                 features.ProxyInvites = features.ProxyInvites.filterNot(_ == invitedPlayer)
-                NextInviteAndRespond(invitedPlayer)
 
               case _ =>
                 //squad no longer exists?
-                NextInviteAndRespond(invitedPlayer)
             }
 
-          case Some(ProximityInvite(invitingPlayer, _, guid)) if EnsureEmptySquad(invitedPlayer, msg) =>
+          case Some(ProximityInvite(invitingPlayer, _, guid)) if EnsureEmptySquad(invitedPlayer) =>
             squadFeatures.get(guid) match {
               case Some(features) =>
                 val squad = features.Squad
                 if(squad.Size < squad.Capacity) {
-                  val positions = squad.Membership.zipWithIndex
-                    .collect { case (member, index) if member.CharId == 0 && squad.Availability(index) && {
-                      val requirementsToMeet = member.Requirements
-                      requirementsToMeet.intersect(tplayer.Certifications) == requirementsToMeet
-                    } =>
-                      (index, member.Requirements.size)
-                    }
-                    .sortBy({ case (_, requirements) => requirements })
+                  val positions = (for {
+                    (member, index) <- squad.Membership.zipWithIndex
+                    if ValidOpenSquadPosition(squad, index, member, tplayer.Certifications)
+                  } yield (index, member.Requirements.size))
+                    .toList
+                    .sortBy({ case (_, reqs) => reqs })
                   ((positions.headOption, positions.lastOption) match {
                     case (Some((first, size1)), Some((_, size2))) if size1 == size2 => Some(first) //join the first available position
                     case (Some(_), Some((last, _))) => Some(last) //join the most demanding position
-                    case _ => None //(None, None)
+                    case _ => None
                   }) match {
                     case Some(position) if JoinSquad(tplayer, squad, position) =>
                       //join this squad
-                      SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))) )
-                      SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
+                      Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None)))
+                      Publish(invitingPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None)))
                       RemoveQueuedInvites(invitedPlayer)
                       features.ProxyInvites = features.ProxyInvites.filterNot(_ == invitedPlayer)
                     case _ =>
@@ -481,104 +712,185 @@ class SquadService extends Actor {
                 }
                 else if(squad.Size == squad.Capacity) {
                   //all available squad positions filled; terminate all remaining invitations
-                  features.SearchForRole = None
-                  features.ProxyInvites = Nil
-                  CleanupInvitesForSquad(guid)
-                  //CleanupInvitesFromPlayer(invitingPlayer)
+                  RemoveProximityInvites(guid)
+                  RemoveAllInvitesToSquad(guid)
+                  //RemoveAllInvitesWithPlayer(invitingPlayer)
                 }
 
               case _ =>
                 //squad no longer exists?
-                NextInviteAndRespond(invitedPlayer)
             }
 
           case _ =>
-            //the invite either timed-out or was withdrawn or is now invalid; select a new one?
-            NextInviteAndRespond(invitedPlayer)
+            //the invite either timed-out or was withdrawn or is now invalid
+            (previousInvites.get(invitedPlayer) match {
+              case Some(SpontaneousInvite(leader)) => (leader.CharId, leader.Name)
+              case Some(VacancyInvite(charId, name, _)) => (charId, name)
+              case Some(ProximityInvite(charId, name, _)) => (charId, name)
+              case Some(LookingForSquadRoleInvite(charId, name, _, _)) => (charId, name)
+              case _ => (0L, "")
+            }) match {
+              case (0L, "") => ;
+              case (charId, name) =>
+                Publish(charId, SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, charId, Some(0L), name, false, Some(None)))
+            }
         }
+        NextInviteAndRespond(invitedPlayer)
 
-      case SquadAction.Membership(SquadRequestType.Leave, leavingPlayer, optionalPlayer, _, _) =>
-        val squad = memberToSquad(leavingPlayer)
-        val leader = squad.Leader.CharId
-        if(leavingPlayer == leader || squad.Size == 2) {
-          //squad leader is leaving his own squad, so it will be disbanded
-          //alternately, squad is only composed of two people, so it will be closed-out when one of them leaves
-          DisbandSquad(squad)
-        }
-        else {
-          if(optionalPlayer.contains(leavingPlayer)) {
-            //leaving the squad of own accord
-            LeaveSquad(tplayer.CharId, squad)
-          }
-          else if(optionalPlayer.contains(leader)) {
-            //kicked by the squad leader
-            SquadEvents.publish( SquadServiceResponse(s"/$leavingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leavingPlayer, Some(leader), tplayer.Name, false, Some(None))) )
-            SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leader, Some(leavingPlayer), "", true, Some(None))) )
-            squadFeatures(squad.GUID).Refuse = leavingPlayer
-            LeaveSquad(leavingPlayer, squad)
-          }
+      case SquadAction.Membership(SquadRequestType.Leave, leavingPlayer, optionalPlayer, name, _) =>
+        GetParticipatingSquad(leavingPlayer) match {
+          case Some(squad) =>
+            val kickedPlayer = if(name.nonEmpty) {
+              //validate player with name
+              LivePlayerList.WorldPopulation({ case (_, a : Avatar) => a.name == name }).headOption match {
+                case Some(player) => UserEvents.keys.find(_ == player.CharId)
+                case None => None
+              }
+            }
+            else {
+              //validate player with id
+              optionalPlayer match {
+                case Some(id) => UserEvents.keys.find(_ == id)
+                case None => None
+              }
+            }
+            val leader = squad.Leader.CharId
+            if(leavingPlayer == leader || squad.Size == 2) {
+              //squad leader is leaving his own squad, so it will be disbanded
+              //alternately, squad is only composed of two people, so it will be closed-out when one of them leaves
+              DisbandSquad(squad)
+            }
+            else {
+              if(kickedPlayer.isEmpty || kickedPlayer.contains(leavingPlayer)) {
+                //leaving the squad of own accord
+                LeaveSquad(tplayer.CharId, squad)
+              }
+              else if(kickedPlayer.contains(leader)) {
+                //kicked by the squad leader
+                Publish(leavingPlayer, SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leavingPlayer, Some(leader), tplayer.Name, false, Some(None)))
+                Publish(leader, SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leader, Some(leavingPlayer), "", true, Some(None)))
+                squadFeatures(squad.GUID).Refuse = leavingPlayer
+                LeaveSquad(leavingPlayer, squad)
+              }
+            }
+
+          case None =>
         }
 
       case SquadAction.Membership(SquadRequestType.Reject, rejectingPlayer, _, _, _) =>
         val rejectedBid = RemoveInvite(rejectingPlayer)
         //(A, B) -> person who made the rejection, person who was rejected
         (rejectedBid match {
-          case Some(SpontaneousInvite(invitingPlayer)) =>
-            //rejectingPlayer is the would-be squad member
-            (Some(rejectingPlayer), Some(invitingPlayer.CharId))
-          case Some(VacancyInvite(invitingPlayer, _, guid))
+          case Some(SpontaneousInvite(leader)) =>
+            //rejectingPlayer is the would-be squad member; the squad leader's request was rejected
+            val invitingPlayerCharId = leader.CharId
+            Refused(rejectingPlayer, invitingPlayerCharId)
+            (Some(rejectingPlayer), Some(invitingPlayerCharId))
+
+          case Some(VacancyInvite(leader, _, guid))
             if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId != rejectingPlayer =>
-            //rejectingPlayer is the would-be squad member
-            (Some(rejectingPlayer), Some(invitingPlayer))
-          case Some(BidForRole(_, guid, _))
-            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId == rejectingPlayer =>
-            //rejectingPlayer is the squad leader
-            (Some(rejectingPlayer), None)
-          case Some(InviteForRole(invitingPlayer, _, guid, position))
-            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId != rejectingPlayer =>
-            //rejectingPlayer is the would-be squad member
-            val features = squadFeatures(guid)
-            features.Refuse = rejectingPlayer //do not bother this player anymore
-            features.ProxyInvites = features.ProxyInvites.filterNot(_ == rejectingPlayer)
-            if(features.ProxyInvites.isEmpty) {
-              features.SearchForRole = None
-            }
-            (None, None)
+            //rejectingPlayer is the would-be squad member; the squad leader's request was rejected
+            Refused(rejectingPlayer, leader)
+            (Some(rejectingPlayer), Some(leader))
+
           case Some(ProximityInvite(_, _, guid))
             if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId != rejectingPlayer =>
-            //rejectingPlayer is the would-be squad member
+            //rejectingPlayer is the would-be squad member; the squad leader's request was rejected
             val features = squadFeatures(guid)
             features.Refuse = rejectingPlayer //do not bother this player anymore
-            features.ProxyInvites = features.ProxyInvites.filterNot(_ == rejectingPlayer)
-            if(features.ProxyInvites.isEmpty) {
-              //all invitations exhausted; this invitation is concluded
+            if((features.ProxyInvites = features.ProxyInvites.filterNot(_ == rejectingPlayer)).isEmpty) {
               features.SearchForRole = None
             }
             (None, None)
+
+          case Some(LookingForSquadRoleInvite(leader, _, guid, _))
+            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId != rejectingPlayer =>
+            //rejectingPlayer is the would-be squad member; the squad leader's request was rejected
+            Refused(rejectingPlayer, leader)
+            val features = squadFeatures(guid)
+            features.Refuse = rejectingPlayer
+            if((features.ProxyInvites = features.ProxyInvites.filterNot(_ == rejectingPlayer)).isEmpty) {
+              features.SearchForRole = None
+            }
+            (None, None)
+
+          case Some(RequestRole(candidate, guid, _))
+            if squadFeatures.get(guid).nonEmpty && squadFeatures(guid).Squad.Leader.CharId == rejectingPlayer =>
+            //rejectingPlayer is the squad leader; candidate is the would-be squad member who was rejected
+            val features = squadFeatures(guid)
+            features.Refuse = rejectingPlayer
+            features.Prompt.cancel
+            (Some(rejectingPlayer), None)
+
           case _ => ;
             (None, None)
         }) match {
           case (Some(rejected), Some(invited)) =>
-            SquadEvents.publish( SquadServiceResponse(s"/$rejected/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, rejected, Some(invited), "", true, Some(None))) )
-            SquadEvents.publish( SquadServiceResponse(s"/$invited/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, invited, Some(rejected), tplayer.Name, false, Some(None))) )
+            Publish(rejected, SquadResponse.Membership(SquadResponseType.Reject, 0, 0, rejected, Some(invited), "", true, Some(None)))
+            Publish(invited, SquadResponse.Membership(SquadResponseType.Reject, 0, 0, invited, Some(rejected), tplayer.Name, false, Some(None)))
           case (Some(rejected), None) =>
-            SquadEvents.publish( SquadServiceResponse(s"/$rejected/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, rejected, Some(rejected), "", true, Some(None))) )
+            Publish(rejected, SquadResponse.Membership(SquadResponseType.Reject, 0, 0, rejected, Some(rejected), "", true, Some(None)))
           case _ => ;
         }
         NextInviteAndRespond(rejectingPlayer)
 
-      case SquadAction.Membership(SquadRequestType.Cancel, cancellingPlayer, _, _, _) =>
-        //huh?
-        log.warn(s"Huh? what does player $cancellingPlayer want to cancel?")
+      case SquadAction.Membership(SquadRequestType.Disband, char_id, _, _, _) =>
+        GetLeadingSquad(char_id, None) match {
+          case Some(squad) =>
+            DisbandSquad(squad)
+          case None => ;
+        }
 
-      case SquadAction.Membership(SquadRequestType.Promote, promotingPlayer, Some(promotedPlayer), _, _) =>
-        (memberToSquad.get(promotingPlayer), memberToSquad.get(promotedPlayer)) match {
-          case (Some(squad), Some(squad2)) if squad.GUID == squad2.GUID && squad.Leader.CharId == promotingPlayer =>
+      case SquadAction.Membership(SquadRequestType.Cancel, cancellingPlayer, _, _, _) =>
+        //get rid of SpontaneousInvite objects and VacancyInvite objects
+        invites.collect {
+          case (id, invite : SpontaneousInvite) if invite.InviterCharId == cancellingPlayer =>
+            RemoveInvite(id)
+          case (id, invite : VacancyInvite) if invite.InviterCharId == cancellingPlayer =>
+            RemoveInvite(id)
+          case (id, invite : LookingForSquadRoleInvite) if invite.InviterCharId == cancellingPlayer =>
+            RemoveInvite(id)
+        }
+        queuedInvites.foreach { case (id : Long, inviteList) =>
+          val inList = inviteList.filterNot {
+            case invite : SpontaneousInvite if invite.InviterCharId == cancellingPlayer => true
+            case invite : VacancyInvite if invite.InviterCharId == cancellingPlayer => true
+            case invite : LookingForSquadRoleInvite if invite.InviterCharId == cancellingPlayer => true
+            case _ => false
+          }
+          if(inList.isEmpty) {
+            queuedInvites.remove(id)
+          }
+          else {
+            queuedInvites(id) = inList
+          }
+        }
+        //get rid of ProximityInvite objects
+        RemoveProximityInvites(cancellingPlayer)
+
+      case SquadAction.Membership(SquadRequestType.Promote, promotingPlayer, Some(_promotedPlayer), promotedName, _) =>
+        val promotedPlayer = (if(promotedName.nonEmpty) {
+          //validate player with name exists
+          LivePlayerList.WorldPopulation({ case (_, a : Avatar) => a.name == promotedName }).headOption match {
+            case Some(player) => UserEvents.keys.find(_ == player.CharId)
+            case None => Some(_promotedPlayer)
+          }
+        }
+        else {
+          Some(_promotedPlayer)
+        }) match {
+          case Some(player) => player
+          case None => -1L
+        }
+        (GetLeadingSquad(promotingPlayer, None), GetParticipatingSquad(promotedPlayer)) match {
+          case (Some(squad), Some(squad2)) if squad.GUID == squad2.GUID =>
             val membership = squad.Membership.filter { _member => _member.CharId > 0 }
-            val (leader, position) = (squad.Leader, 0)
+            val leader = squad.Leader
             val (member, index) = membership.zipWithIndex.find { case (_member, _) => _member.CharId == promotedPlayer }.get
-            log.info(s"Player ${leader.Name} steps down from leading ${squad.Task}")
-            SwapMemberPosition(squad, leader, member)
+            val features = squadFeatures(squad.GUID)
+            SwapMemberPosition(leader, member)
+            //cancel previous leader invite prompt, if any
+            features.Prompt.cancel
             //move around invites so that the proper squad leader deals with them
             val leaderInvite = invites.remove(promotingPlayer)
             val leaderQueuedInvites = queuedInvites.remove(promotingPlayer).toList.flatten
@@ -600,31 +912,33 @@ class SquadService extends Actor {
                     queuedInvites += promotedPlayer -> (xs ++ queuedInvites.remove(promotedPlayer).toList.flatten)
                 }
             }
-            log.info(s"Promoting player ${leader.Name} to be the leader of ${squad.Task}")
-            membership.foreach { _member =>
-              SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.PromoteMember(squad, promotedPlayer, index, position)))
+            debug(s"Promoting player ${leader.Name} to be the leader of ${squad.Task}")
+            Publish(features.ToChannel, SquadResponse.PromoteMember(squad, promotedPlayer, index, 0))
+            if(features.Listed) {
+              Publish(promotingPlayer, SquadResponse.SetListSquad(PlanetSideGUID(0)))
+              Publish(promotedPlayer, SquadResponse.SetListSquad(squad.GUID))
             }
-            SquadEvents.publish(SquadServiceResponse(s"/$promotingPlayer/Squad", SquadResponse.AssociateWithSquad(PlanetSideGUID(0))))
-            SquadEvents.publish(SquadServiceResponse(s"/$promotedPlayer/Squad", SquadResponse.AssociateWithSquad(squad.GUID)))
             UpdateSquadListWhenListed(
-              squad,
+              features,
               SquadInfo().Leader(leader.Name)
             )
-            UpdateSquadDetail(squad.GUID, squad,
+            UpdateSquadDetail(
+              squad.GUID,
               SquadDetail()
                 .LeaderCharId(leader.CharId)
                 .Field3(value = 0L)
                 .LeaderName(leader.Name)
                 .Members(List(
-                  SquadPositionEntry(position, SquadPositionDetail().CharId(member.CharId).Name(member.Name)),
-                  SquadPositionEntry(index, SquadPositionDetail().CharId(leader.CharId).Name(leader.Name))
+                  SquadPositionEntry(0, SquadPositionDetail().CharId(leader.CharId).Name(leader.Name)),
+                  SquadPositionEntry(index, SquadPositionDetail().CharId(member.CharId).Name(member.Name))
                 ))
             )
-
-          case msg =>
-            log.warn(s"Unsupported squad behavior: $msg")
+          case _ => ;
         }
 
+      case SquadAction.Membership(event, _, _, _, _) =>
+        debug(s"SquadAction.Membership: $event is not yet supported")
+
       case SquadAction.Waypoint(_, wtype, _, info) =>
         val playerCharId = tplayer.CharId
         (GetLeadingSquad(tplayer, None) match {
@@ -640,25 +954,11 @@ class SquadService extends Actor {
         }) match {
           case (Some(squad), Some(_)) =>
             //waypoint added or updated
-            squad.Membership
-              .filterNot { member => member.CharId == tplayer.CharId }
-              .foreach { member =>
-                val charId = member.CharId
-                SquadEvents.publish(
-                  SquadServiceResponse(s"/$charId/Squad", SquadResponse.WaypointEvent(WaypointEventAction.Add, playerCharId, wtype, None, info, 1))
-                )
-              }
+            SquadServiceResponse(s"/${squadFeatures(squad.GUID).ToChannel}/Squad", tplayer.CharId, SquadResponse.WaypointEvent(WaypointEventAction.Add, playerCharId, wtype, None, info, 1))
 
           case (Some(squad), None) =>
             //waypoint removed?
-            squad.Membership
-              .filterNot { member => member.CharId == tplayer.CharId }
-              .foreach { member =>
-                val charId = member.CharId
-                SquadEvents.publish(
-                  SquadServiceResponse(s"/$charId/Squad", SquadResponse.WaypointEvent(WaypointEventAction.Remove, playerCharId, wtype, None, None, 0))
-                )
-              }
+            SquadServiceResponse(s"/${squadFeatures(squad.GUID).ToChannel}/Squad", tplayer.CharId, SquadResponse.WaypointEvent(WaypointEventAction.Remove, playerCharId, wtype, None, None, 0))
 
           case msg =>
             log.warn(s"Unsupported squad waypoint behavior: $msg")
@@ -674,57 +974,60 @@ class SquadService extends Actor {
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             if(squad.Task.nonEmpty && squad.ZoneId > 0) {
               tplayer.SquadLoadouts.SaveLoadout(squad, squad.Task, line)
-              sender ! SquadServiceResponse("", SquadResponse.ListSquadFavorite(line, squad.Task))
+              Publish(sender, SquadResponse.ListSquadFavorite(line, squad.Task))
             }
 
           case LoadSquadFavorite() =>
-            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
-            tplayer.SquadLoadouts.LoadLoadout(line) match {
-              case Some(loadout : SquadLoadout) if squad.Size == 1 =>
-                log.info(s"${tplayer.Name} is loading a squad composition: $loadout")
-                SquadService.LoadSquadDefinition(squad, loadout)
-                sender ! SquadServiceResponse("", SquadResponse.AssociateWithSquad(squad.GUID))
-                UpdateSquadList(squad, SquadService.SquadList.Publish(squad))
-                UpdateSquadDetail(PlanetSideGUID(0), squad)
-              case _ =>
+            if(pSquadOpt.isEmpty || pSquadOpt == lSquadOpt) {
+              val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
+              tplayer.SquadLoadouts.LoadLoadout(line) match {
+                case Some(loadout : SquadLoadout) if squad.Size == 1 =>
+                  SquadService.LoadSquadDefinition(squad, loadout)
+                  UpdateSquadListWhenListed(squadFeatures(squad.GUID), SquadService.SquadList.Publish(squad))
+                  Publish(sender, SquadResponse.AssociateWithSquad(PlanetSideGUID(0)))
+                  InitSquadDetail(PlanetSideGUID(0), Seq(tplayer.CharId), squad)
+                  UpdateSquadDetail(squad)
+                  Publish(sender, SquadResponse.AssociateWithSquad(squad.GUID))
+                case _ =>
+              }
             }
 
           case DeleteSquadFavorite() =>
             tplayer.SquadLoadouts.DeleteLoadout(line)
-            sender ! SquadServiceResponse("", SquadResponse.ListSquadFavorite(line, ""))
+            Publish(sender, SquadResponse.ListSquadFavorite(line, ""))
 
           case ChangeSquadPurpose(purpose) =>
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's task to $purpose")
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Task = purpose
-            UpdateSquadListWhenListed(squad, SquadInfo().Task(purpose))
-            UpdateSquadDetail(squad.GUID, squad, SquadDetail().Task(purpose))
+            UpdateSquadListWhenListed(squadFeatures(squad.GUID), SquadInfo().Task(purpose))
+            UpdateSquadDetail(squad.GUID, SquadDetail().Task(purpose))
 
           case ChangeSquadZone(zone_id) =>
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has changed squad's ops zone to $zone_id")
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.ZoneId = zone_id.zoneId.toInt
-            UpdateSquadListWhenListed(squad, SquadInfo().ZoneId(zone_id))
+            UpdateSquadListWhenListed(squadFeatures(squad.GUID), SquadInfo().ZoneId(zone_id))
             InitialAssociation(squad)
-            sender ! SquadServiceResponse("", SquadResponse.Detail(
+            Publish(sender, SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+            UpdateSquadDetail(
               squad.GUID,
-              SquadService.Detail.Publish(squad))
+              squad.GUID,
+              Seq(squad.Leader.CharId),
+              SquadDetail().ZoneId(zone_id)
             )
-            UpdateSquadDetail(squad.GUID, squad.Membership.map { _m => _m.CharId }.filterNot { _ == squad.Leader.CharId }, SquadDetail().ZoneId(zone_id))
 
           case CloseSquadMemberPosition(position) =>
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
-              case Some(true) =>
+              case Some(true) if position > 0 => //do not close squad leader position; undefined behavior
                 squad.Availability.update(position, false)
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has closed the #$position position in squad")
                 val memberPosition = squad.Membership(position)
                 if(memberPosition.CharId > 0) {
                   LeaveSquad(memberPosition.CharId, squad)
                 }
                 memberPosition.Close()
-                UpdateSquadListWhenListed(squad, SquadInfo().Capacity(squad.Capacity))
-                UpdateSquadDetail(squad.GUID, squad,
+                UpdateSquadListWhenListed(squadFeatures(squad.GUID), SquadInfo().Capacity(squad.Capacity))
+                UpdateSquadDetail(
+                  squad.GUID,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Closed)))
                 )
               case Some(false) | None => ;
@@ -734,10 +1037,10 @@ class SquadService extends Actor {
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(false) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has opened the #$position position in squad")
                 squad.Availability.update(position, true)
-                UpdateSquadListWhenListed(squad, SquadInfo().Capacity(squad.Capacity))
-                UpdateSquadDetail(squad.GUID, squad,
+                UpdateSquadListWhenListed(squadFeatures(squad.GUID), SquadInfo().Capacity(squad.Capacity))
+                UpdateSquadDetail(
+                  squad.GUID,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Open)))
                 )
               case Some(true) | None => ;
@@ -747,9 +1050,9 @@ class SquadService extends Actor {
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(true) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the role of squad position #$position")
                 squad.Membership(position).Role = role
-                UpdateSquadDetail(squad.GUID, squad,
+                UpdateSquadDetail(
+                  squad.GUID,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Role(role))))
                 )
               case Some(false) | None => ;
@@ -759,9 +1062,9 @@ class SquadService extends Actor {
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(true) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the orders for squad position #$position")
                 squad.Membership(position).Orders = orders
-                UpdateSquadDetail(squad.GUID, squad,
+                UpdateSquadDetail(
+                  squad.GUID,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().DetailedOrders(orders))))
                 )
               case Some(false) | None => ;
